#Simple color converter 
#
#Usage: rgb2xlc.py (r,g,b)
#input: 3-tuple.
#output: scalar 0-255.

import sys
from math import fabs
from math import sqrt
from ast import literal_eval

#-----------------------------------------------------------------------------
def xlc2rgb(xlc):
    r8 = ((((xlc>>2)&0x3E)|((xlc>>7)&1))/63.0)*255.0
    g8 = ((((xlc<<3)&0x38)|((xlc>>5)&7))/63.0)*255.0
    b8 = ((((xlc<<1)&0x3E)|((xlc>>4)&1))/63.0)*255.0
    return (r8,g8,b8)
    
def rgb2xlc(rgb):
    if isinstance(rgb,tuple):
        ir = rgb[0]
        ig = rgb[1]
        ib = rgb[2]
    else:
        print "Blah. Gimmie a tuple."
        sys.exit(2)
    pass
    dist = 9999.0
    cur_xlc = 0
    for i in range(256):
        incol = xlc2rgb(i)
        tr = fabs(incol[0]-ir)
        tg = fabs(incol[1]-ig)
        tb = fabs(incol[2]-ib)
        tdist = sqrt((tr*tr)+(tg*tg)+(tb*tb)) #euclidean distance formula
        if tdist<dist:
            dist = tdist
            cur_xlc = i
    return cur_xlc
    
    
#-----------------------------------------------------------------------------

if len(sys.argv)<2:
    print("Error: Not enough arguments supplied.")
    sys.exit(2)
    
intup = sys.argv[1]
mytup = literal_eval(intup)
if not isinstance(mytup,tuple):
    print("Input is not a tuple.")
    sys.exit(2)
if len(mytup)!=3:
    print("Input tuple is not length 3")
    sys.exit(2)
val = rgb2xlc(mytup)
print "Input: "+str(mytup)+", output xLIBc code: "+str(val)




